import org.junit.Assert;
import org.junit.Test;

public class TestMyArrayList<T> {
    MyArrayList myArrayList = new MyArrayList(3);

    @Test
    public void addTest() {
        //Given
        myArrayList.add(1);
        myArrayList.add(4);
        //Then
        int expected = 5;
        int actual = myArrayList.getMyArray().length;

        //When
        Assert.assertEquals(expected, actual);

    }

    @Test
    public void removeTest() {
        //Given
        myArrayList.add(1);
        myArrayList.remove(1);
        //Then
        int expected = 3;
        int actual = myArrayList.getMyArray().length;

        //When
        Assert.assertEquals(expected, actual);

    }

    @Test
    public void sizeTest() {
        //Given
        myArrayList.add(5);
        //Then
        int expected = 4;
        int actual = myArrayList.size();

        //When
        Assert.assertEquals(expected, actual);

    }

    @Test
    public void setTest(){
        //Given
        myArrayList.add(1);

        //Then
        myArrayList.set(3, 6);
        Object expected = 6;
        Object actual = myArrayList.getMyArray()[3];

        //When
        Assert.assertEquals(expected, actual);

    }

    @Test
    public void clearTest(){
        //Given
        myArrayList.add(1);
        myArrayList.clear();
        //Then
        Object expected = 0;
        Object actual = myArrayList.size();

        //When
        Assert.assertEquals(expected, actual);

    }

    @Test
    public void getTest(){
        //Given
        myArrayList.add(1);
        myArrayList.add(6);
        myArrayList.get(4);

        //Then
        Object expected = 6;
        Object actual = myArrayList.get(4);


        //When
        Assert.assertEquals(expected, actual);

    }

    @Test
    public void isEmptyTrueTest(){
        //Given
        myArrayList.add(1);
        myArrayList.clear();

        //Then
        boolean actual = myArrayList.isEmpty();

        //When
        Assert.assertTrue(actual);

    }
    @Test
    public void isEmptyFalseTest(){
        //Given
        myArrayList.add(1);


        //Then
        boolean actual = myArrayList.isEmpty();

        //When
        Assert.assertFalse(actual);

    }

    @Test
    public void containsTrueTest(){
        //Given
        myArrayList.add(1);
        myArrayList.add(12);
        myArrayList.add(8);

        //Then
        Boolean actual = myArrayList.contains(12);

        //When
        Assert.assertTrue(actual);

    }
    @Test
    public void containsFalseTest(){
        //Given
        myArrayList.add(1);
        myArrayList.add(7);
        myArrayList.add(3);

        //Then
        Boolean actual = myArrayList.contains(12);

        //When
        Assert.assertFalse(actual);

    }
}